const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const memberships = sequelize.define(
    'memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"trialing",


"active",


"past_due",


"canceled",


"expired"

        ],

      },

started_at: {
        type: DataTypes.DATE,
      
      

      },

current_period_end_at: {
        type: DataTypes.DATE,
      
      

      },

canceled_at: {
        type: DataTypes.DATE,
      
      

      },

stripe_customer_ref: {
        type: DataTypes.TEXT,
      
      

      },

stripe_subscription_ref: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.memberships.hasMany(db.stripe_events, {
      as: 'stripe_events_membership',
      foreignKey: {
          name: 'membershipId',
      },
      constraints: false,
    });




















//end loop



    db.memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.memberships.belongsTo(db.membership_plans, {
      as: 'membership_plan',
      foreignKey: {
        name: 'membership_planId',
      },
      constraints: false,
    });




    db.memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return memberships;
};


